package rege.chemicalcompound.mod115.compatibleboo.tools;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.nio.charset.Charset;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;

import rege.chemicalcompound.misc.compatibleboo.helper.ZipHelper;

/**
 * @author RheniumGermanide
 */
public class GenVanillaBambooTextures extends ZipHelper {
    /**
     * The latest stable Minecraft client jat URL string.
     */
    public static final String RES_URL = "https://piston-data.mojang.com/v1/objects/6f67d19b4467240639cb2c368ffd4b94ba889705/client.jar";
    /**
     * The {@code pack.mcmeta}'s body.
     */
    public static final String PACK_MCMETA = "{\n  \"pack\": {\n    \"pack_format\": 6,\n    \"description\": \"This resource pack is automatically generated by GenVanillaBambooTextures by RheniumGermanide\"\n  }\n}\n";

    /**
     * Get Minecraft resources.
     */
    public static void getMcRes() {
        if (!new File("1.21.3.zip").exists()) {
            download(RES_URL, ".", "1.21.3.zip");
        }
        try {
            final FileInputStream INPUT = new FileInputStream("1.20.4.zip");
            final ZipInputStream ZIPINPUT = new ZipInputStream(new BufferedInputStream(INPUT), Charset.forName("UTF-8"));
            ZipEntry ze = null;
            while ((ze = ZIPINPUT.getNextEntry()) != null) {
                if (ze.getName().equals("assets/minecraft/textures/block/bamboo_block.png")) {
                    writefile(readFromZip(ZIPINPUT), "assets/minecraft/textures/block", "bamboo_block.png");
                    continue;
                }
                if (ze.getName().equals("assets/minecraft/textures/block/bamboo_block_top.png")) {
                    writefile(readFromZip(ZIPINPUT), "assets/minecraft/textures/block", "bamboo_block_top.png");
                    continue;
                }
                if (ze.getName().equals("assets/minecraft/textures/block/stripped_bamboo_block.png")) {
                    writefile(readFromZip(ZIPINPUT), "assets/minecraft/textures/block", "stripped_bamboo_block.png");
                    continue;
                }
                if (ze.getName().equals("assets/minecraft/textures/block/stripped_bamboo_block_top.png")) {
                    writefile(readFromZip(ZIPINPUT), "assets/minecraft/textures/block", "stripped_bamboo_block_top.png");
                    continue;
                }
                if (ze.getName().equals("assets/minecraft/textures/block/bamboo_door_bottom.png")) {
                    writefile(readFromZip(ZIPINPUT), "assets/minecraft/textures/block", "bamboo_door_bottom.png");
                    continue;
                }
                if (ze.getName().equals("assets/minecraft/textures/block/bamboo_door_top.png")) {
                    writefile(readFromZip(ZIPINPUT), "assets/minecraft/textures/block", "bamboo_door_top.png");
                    continue;
                }
                if (ze.getName().equals("assets/minecraft/textures/block/bamboo_planks.png")) {
                    writefile(readFromZip(ZIPINPUT), "assets/minecraft/textures/block", "bamboo_planks.png");
                    continue;
                }
                if (ze.getName().equals("assets/minecraft/textures/block/bamboo_mosaic.png")) {
                    writefile(readFromZip(ZIPINPUT), "assets/minecraft/textures/block", "bamboo_mosaic.png");
                    continue;
                }
                if (ze.getName().equals("assets/minecraft/textures/block/bamboo_fence.png")) {
                    writefile(readFromZip(ZIPINPUT), "assets/minecraft/textures/block", "bamboo_fence.png");
                    continue;
                }
                if (ze.getName().equals("assets/minecraft/textures/block/bamboo_fence_particle.png")) {
                    writefile(readFromZip(ZIPINPUT), "assets/minecraft/textures/block", "bamboo_fence_particle.png");
                    continue;
                }
                if (ze.getName().equals("assets/minecraft/textures/block/bamboo_fence_gate.png")) {
                    writefile(readFromZip(ZIPINPUT), "assets/minecraft/textures/block", "bamboo_fence_gate.png");
                    continue;
                }
                if (ze.getName().equals("assets/minecraft/textures/block/bamboo_fence_gate_particle.png")) {
                    writefile(readFromZip(ZIPINPUT), "assets/minecraft/textures/block", "bamboo_fence_gate_particle.png");
                    continue;
                }
                if (ze.getName().equals("assets/minecraft/textures/block/bamboo_trapdoor.png")) {
                    writefile(readFromZip(ZIPINPUT), "assets/minecraft/textures/block", "bamboo_trapdoor.png");
                    continue;
                }
                if (ze.getName().equals("assets/minecraft/textures/item/bamboo_door.png")) {
                    writefile(readFromZip(ZIPINPUT), "assets/minecraft/textures/item", "bamboo_door.png");
                    continue;
                }
                if (ze.getName().equals("assets/minecraft/textures/item/bamboo_sign.png")) {
                    writefile(readFromZip(ZIPINPUT), "assets/minecraft/textures/item", "bamboo_sign.png");
                    continue;
                }
                if (ze.getName().equals("assets/minecraft/textures/item/bamboo_raft.png")) {
                    writefile(readFromZip(ZIPINPUT), "assets/minecraft/textures/item", "bamboo_raft.png");
                    continue;
                }
            }
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

    /**
     * Run the main program. Can also be run with {@code java -cp * rege.chemicalcompound.mod115.compatibleboo.tools.GenVanillaBambooTextures}.
     * @param args Command line arguments.
     */
    public static void main(String[] args) {
        getMcRes();
        System.err.println("The resource pack is generated into assets/ directory.\nThe following content is the body of pack.mcmeta:");
        System.out.println(PACK_MCMETA);
    }
}